Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## groovy.transform
[Java] Annotation Type IndexedProperty

    java.lang.Object
      groovy.transform.IndexedProperty

    @Retention(RetentionPolicy.SOURCE)
    @Target({ElementType.FIELD})
    @GroovyASTTransformationClass("org.codehaus.groovy.transform.IndexedPropertyASTTransformation")
    public @interface IndexedProperty

Field annotation used with properties to provide an indexed getter and setter for the property. Groovy provides nice GPath syntax support for accessing indexed properties but Java tools or frameworks may expect the JavaBean style setters and getters.

Example usage: suppose you have a class with the following properties:

     @IndexedProperty FieldType[] someField
     @IndexedProperty List otherField
     @IndexedProperty List furtherField

will add the following methods to the class containing the properties:

     FieldType getSomeField(int index) {
         someField[index]
     }
     FieldType getOtherField(int index) {
         otherField[index]
     }
     Object getFurtherField(int index) {
         furtherField[index]
     }
     void setSomeField(int index, FieldType val) {
         someField[index] = val
     }
     void setOtherField(int index, FieldType val) {
         otherField[index] = val
     }
     void setFurtherField(int index, Object val) {
         furtherField[index] = val
     }

Normal Groovy visibility rules for properties apply (i.e. no `public`, `private` or `package` visibility can be specified) or you will receive a compile-time error message. The normal Groovy property getters and setters will also be created.

Authors:
  Paul King

Since:
  1.7.3

Method Summary

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Groovy Documentation